package com.zipcodewilmington.froilansfarm;

import com.zipcodewilmington.froilansfarm.Classes.Animals.Person;
import com.zipcodewilmington.froilansfarm.Classes.Crops.ArbitraryPlant;
import com.zipcodewilmington.froilansfarm.Classes.Crops.CornStalk;
import com.zipcodewilmington.froilansfarm.Classes.Crops.TomatoPlant;
import com.zipcodewilmington.froilansfarm.Classes.Storage.CropRow;
import com.zipcodewilmington.froilansfarm.Classes.Farm;
import com.zipcodewilmington.froilansfarm.Interfaces.*;
import org.junit.*;

public class Tests {

    @Test
    public void SundayTest(){
        Farm farm = new Farm();
        farm.morning();

        for (Person person : farm.farmHouse) {
            if (person instanceof Farmer) {
                    if(person == farm.froilan){
                        person.plant(farm.field, 0,new TomatoPlant());
                        person.plant(farm.field, 1,new TomatoPlant());
                    }
                    else if(person == farm.freelan){
                        person.plant(farm.field,2,new ArbitraryPlant());
                    }else System.out.println("Get off ma field");
                }
            }
        }

        @Test
        public void MondayTest(){

        Farm farm = new Farm();
        farm.morning();

        for (Person person : farm.farmHouse) {

            if (person == farm.froilan) {
                farm.cropduster.operate(farm);
                farm.cropduster.makeNoise();

                for (CropRow croprow: farm.field) {
                    farm.cropduster.fertilize(croprow);
                }
            }
        }
    }

    @Test
    public void TuesdayTest(){
        Farm farm = new Farm();
        farm.morning();

        for (Person person : farm.farmHouse) {
            if (person == farm.froilan) {
                farm.froilan.mount(farm.tractor);
                farm.tractor.operate(farm);
                farm.froilan.ride(farm.tractor);
                for (CropRow cropRow : farm.field) {
                    farm.tractor.harvest(cropRow);
                }
                farm.froilan.dismount(farm.tractor);
            }
            if (person == farm.freelan) {
                CornStalk corn = new CornStalk();
                farm.freelan.plant(farm.field, farm.field.size()-1, corn);
            }
        }
    }
    @Test
    public void WednesdayTest(){
        Farm farm = new Farm();
        farm.morning();

        for (Person person : farm.farmHouse) {
            if (person == farm.freelan) {
                farm.cropduster.fertilize(farm.field.get(farm.field.size()-1));
            }
        }
    }

}